/* Copyright (C) 2021,2022 fef <owo@fef.moe>.  All rights reserved. */

#pragma once

#ifndef _ARCH_TRAP_H_
#error "This file is not meant to be included directly, use <arch/trap.h>"
#endif

/**
 * @brief Complete context save on the i386.
 */
struct i386_trap_frame {
	/* extra pointer pushed manually, see the assembly routines */
	struct i386_hw_frame *hw_frame;

	u32 edi;
	u32 esi;
	u32 ebp;
	u32 esp;
	u32 ebx;
	u32 edx;
	u32 ecx;
	u32 eax;
} __packed;
typedef struct i386_trap_frame trap_frame_t;
