/* Copyright (C) 2021,2022 fef <owo@fef.moe>.  All rights reserved. */

#pragma once
#ifndef _ARCH_VMPARAM_H_
#error "This file is not meant to be included directly, use <arch/vmparam.h>"
#endif

/** @brief Userland memory region */
#define USER_OFFSET 0x00000000
#define USER_LENGTH 0x80000000

/** @brief Direct (contiguous) mapping of physical memory, also used as heap */
#define DMAP_OFFSET 0x80000000
/* this gives us ~ 1.7 GB of effectively usable RAM for *everything*, much wow */
#define DMAP_LENGTH 0x70000000

/** @brief Kernel image (code + data) */
#define KERN_OFFSET 0xf0000000
#define KERN_LENGTH 0x0f000000
#define KERNBASE    KERN_OFFSET

/** @brief Recursive Page Directory map */
#define X86_PD_OFFSET 0xffc00000
#define X86_PD_LENGTH 0x00400000
