/* Copyright (C) 2021,2022 fef <owo@fef.moe>.  All rights reserved. */

#include <gay/irq.h>
#include <gay/mm.h>
#include <gay/sched.h>

/**
 * @brief Main kernel entry point.
 *
 * This is the first truly architecture independent code that will be executed.
 * It bootstraps the entire kernel core and drivers, and when done, spawns the
 * init daemon.
 * The arguments passed to this function are the kernel command line,
 * as obtained by the bootloader.
 *
 * (that is, when it's finished at some point lmao)
 */
int main(int argc, char *argv[])
{
	int err;

	kmalloc_init();

	irq_init();

	err = sched_init();
	if (err)
		return err;

	return 0;
}
